# {{ ansible_managed }}

{% if app_upstream_url %}
upstream upstream_app {
    server {{ app_upstream_url }};
}
{% endif %}

server {
        listen 80;
        server_name {{ nginx_server_name }};

	root {{ app_public_path }};

	server_tokens off;
{% if letsencrypt %}
        include acme.include;
{% endif %}
{% if app_public_path %}	
	location /favicon.ico {
		root {{ app_public_path }};
		break;
	}
{% endif %}

{% if nginx_ssl_redirect %}
        location / {
                return 302 https://$server_name$request_uri;
        }
{% endif%}

{% for item in nginx_options %}
        {{ item }}
{% endfor %}

{% if app_upstream_url %}
        try_files $uri @proxy;
        location @proxy {
                proxy_redirect off;
                proxy_set_header Host $host;
                proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
                proxy_set_header X-Forwarded-Proto {{ public_scheme|default('$scheme') }};
                proxy_pass http://upstream_app;
        }
{% endif %}
        access_log  /var/log/nginx/{{ nginx_server_name }}.access.log;
        error_log /var/log/nginx/{{ nginx_server_name }}.error.log;

}


{% if nginx_ssl %}
server {
  listen 443 ssl;
  listen [::]:443 ssl;

  ssl_certificate {{ nginx_ssl_cert }};
  ssl_certificate_key {{ nginx_ssl_key }};

  ssl_session_timeout  5m;

  ssl_protocols TLSv1.1 TLSv1.2;
  ssl_ciphers "EECDH+ECDSA+AESGCM EECDH+aRSA+AESGCM EECDH+ECDSA+SHA384 EECDH+ECDSA+SHA256 EECDH+aRSA+SHA384 EECDH+aRSA+SHA256 EECDH+aRSA+RC4 EECDH EDH+aRSA !RC4 !aNULL !eNULL !LOW !3DES !MD5 !EXP !PSK !SRP !DSS";
  ssl_prefer_server_ciphers   on;

  server_name {{ nginx_server_name }};

  root {{ app_public_path }};

  server_tokens off;

{% if letsencrypt %}
        include acme.include;
{% endif %}

{% for item in nginx_options %}
{{ item }}
{% endfor %}

{% if app_upstream_url %}
  try_files $uri @proxy;

  location @proxy {
    proxy_redirect off;
    proxy_set_header Host {{ nginx_server_name }};
    proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
    proxy_set_header X-Forwarded-Proto {{ public_scheme|default('$scheme') }};
    proxy_pass http://upstream_app;
  }
{% endif %}

   access_log  /var/log/nginx/{{ nginx_server_name }}.access.log;
   error_log /var/log/nginx/{{ nginx_server_name }}.error.log;
}
{% endif %}
